/* Problem URL: https://codeforces.com/problemset/problem/2035/D */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 1

void solve()
{
    int n;
    cin >> n;
    vl a(n);
    cin >> a;

    ll mod = 1e9 + 7;

    vvi rem(n);
    vl count(n);

    while (~a[n - 1] & 1) {
        count[n - 1]++;
        a[n - 1] >>= 1;
    }

    stack<tuple<ll, ll, int>> s;
    s.emplace(a[n - 1], count[n - 1], n - 1);

    auto comp = [&](tuple<ll, ll, int> al, tuple<ll, ll, int> bl) {
        auto [a, pa, _] = al;
        auto [b, pb, __] = bl;

        if (pb >= 30) {
            return false;
        }

        if (pa == 0) {
            return a > (b << pb);
        }

        return (a << pa) + (b << pb) > a + (b << (pb + pa));
    };

    for (int i = n - 2; i >= 0; i--) {
        while (~a[i] & 1) {
            count[i]++;
            a[i] >>= 1;
        }

        tuple<ll, ll, int> tup = {a[i], count[i], i};
        auto [a, pa, _] = tup;

        while (!s.empty() && comp(tup, s.top())) {
            auto [b, pb, _] = s.top();
            s.pop();
            if (!s.empty()) {
                auto &[tb, tpb, __] = s.top();
                tpb += pb;
            }
        }

        if (s.empty()) {
            s.emplace(tup);
            continue;
        }

        auto &[b, pb, j] = s.top();
        rem[j].push_back(i);
        s.emplace(tup);
    }

    auto fpow = [&](ll a, ll p) {
        ll ans = 1;
        rep(i, 60) {
            if ((p >> i) & 1) {
                ans = (ans * a) % mod;
            }

            a = (a * a) % mod;
        }

        return ans;
    };

    ll total = 0;
    rep(i, n) {
        repv(j, rem[i]) {
            total = ((total - a[j] * fpow(2, count[j])) % mod + mod) % mod;
            total = (total + a[j]) % mod;
            count[i] += count[j];
        }

        total = (total + a[i] * fpow(2, count[i])) % mod;
        cout << total << " \n"[i == n - 1];
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
